> ## Documentation Index
> Fetch the complete documentation index at: https://www.voiceflow.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Add integration tool

> Adds one of an integration's catalog tools to the environment's draft and returns the `integrationToolID` that the tool create operation attaches. Adding a tool connects nothing, so the integration still has to be connected before the tool can run.



## OpenAPI

````yaml /specs-prettified/realtime/openapi.stable.json post /v1/stable/integration/{integration}/tool
openapi: 3.0.0
info:
  title: Realtime
  description: Realtime gateway API service
  version: 1.0.0
  contact: {}
servers:
  - url: https://realtime-api.voiceflow.com
security: []
tags: []
paths:
  /v1/stable/integration/{integration}/tool:
    post:
      tags:
        - Integration
      summary: Add integration tool
      description: Adds one of an integration's catalog tools to the environment's
        draft and returns the `integrationToolID` that the tool create operation
        attaches. Adding a tool connects nothing, so the integration still has
        to be connected before the tool can run.
      operationId: StableIntegrationController_addTool
      parameters:
        - name: integration
          required: true
          in: path
          schema:
            type: string
          x-vf-doc:
            description: The integration identifier, as `GET /v1/stable/integration` lists
              it (for example `twilio`).
          description: The integration identifier, as `GET /v1/stable/integration` lists
            it (for example `twilio`).
        - name: projectID
          required: true
          in: query
          schema:
            type: string
            description: The ID of the project to operate on.
        - name: environmentAlias
          required: true
          in: query
          schema:
            type: string
            description: The alias of the environment to operate on (e.g. `main`).
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/StableIntegrationAddToolRequest"
      responses:
        "200":
          description: Returns the `integrationToolID` to attach the tool with, and
            `created`, which is false when the tool had already been added to
            this environment and nothing changed.
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/StableIntegrationAddToolResponse"
          x-vf-doc:
            description: Returns the `integrationToolID` to attach the tool with, and
              `created`, which is false when the tool had already been added to
              this environment and nothing changed.
      security:
        - token: []
components:
  schemas:
    StableIntegrationAddToolRequest:
      type: object
      properties:
        toolName:
          description: The catalog tool to add, as get_schema lists it, such as
            `google_sheets_update_spreadsheet`. It must belong to the
            integration in the path.
          allOf:
            - $ref: "#/components/schemas/IntegrationToolName"
          enum:
            - example_dynamic_schema
            - zendesk_find_user
            - zendesk_find_group
            - zendesk_find_ticket
            - zendesk_create_ticket
            - zendesk_update_ticket
            - zendesk_add_ticket_comment
            - zendesk_update_organization
            - zendesk_find_latest_comment
            - salesforce_create_lead
            - salesforce_update_lead
            - salesforce_create_contact
            - salesforce_update_contact
            - salesforce_create_case
            - salesforce_update_case
            - salesforce_add_comment_to_case
            - shopify_get_products
            - shopify_get_order
            - shopify_cancel_order
            - shopify_update_order
            - google_sheets_create_spreadsheet
            - google_sheets_update_spreadsheet
            - google_sheets_read_spreadsheet
            - google_sheets_append_spreadsheet
            - google_sheets_read_row
            - google_gmail_send_email
            - airtable_create_records
            - airtable_delete_records
            - airtable_get_record
            - airtable_list_records
            - airtable_update_records
            - make_run_scenario
            - twilio_send_sms
            - hubspot_create_contact
            - hubspot_create_lead
            - hubspot_create_ticket
          x-enumNames:
            - EXAMPLE_DYNAMIC_SCHEMA
            - ZENDESK_FIND_USER
            - ZENDESK_FIND_GROUP
            - ZENDESK_FIND_TICKET
            - ZENDESK_CREATE_TICKET
            - ZENDESK_UPDATE_TICKET
            - ZENDESK_ADD_TICKET_COMMENT
            - ZENDESK_UPDATE_ORGANIZATION
            - ZENDESK_FIND_LATEST_TICKET_COMMENT
            - SALESFORCE_CREATE_LEAD
            - SALESFORCE_UPDATE_LEAD
            - SALESFORCE_CREATE_CONTACT
            - SALESFORCE_UPDATE_CONTACT
            - SALESFORCE_CREATE_CASE
            - SALESFORCE_UPDATE_CASE
            - SALESFORCE_ADD_COMMENT_TO_CASE
            - SHOPIFY_GET_PRODUCTS
            - SHOPIFY_GET_ORDER
            - SHOPIFY_CANCEL_ORDER
            - SHOPIFY_UPDATE_ORDER
            - GOOGLE_SHEETS_CREATE_SPREADSHEET
            - GOOGLE_SHEETS_UPDATE_SPREADSHEET
            - GOOGLE_SHEETS_READ_SPREADSHEET
            - GOOGLE_SHEETS_APPEND_SPREADSHEET
            - GOOGLE_SHEETS_READ_ROW
            - GOOGLE_GMAIL_SEND_EMAIL
            - AIRTABLE_CREATE_RECORDS
            - AIRTABLE_DELETE_RECORDS
            - AIRTABLE_GET_RECORD
            - AIRTABLE_LIST_RECORDS
            - AIRTABLE_UPDATE_RECORDS
            - MAKE_RUN_SCENARIO
            - TWILIO_SEND_SMS
            - HUBSPOT_CREATE_CONTACT
            - HUBSPOT_CREATE_LEAD
            - HUBSPOT_CREATE_TICKET
      required:
        - toolName
      additionalProperties: false
    IntegrationToolName:
      type: string
      enum:
        - example_dynamic_schema
        - zendesk_find_user
        - zendesk_find_group
        - zendesk_find_ticket
        - zendesk_create_ticket
        - zendesk_update_ticket
        - zendesk_add_ticket_comment
        - zendesk_update_organization
        - zendesk_find_latest_comment
        - salesforce_create_lead
        - salesforce_update_lead
        - salesforce_create_contact
        - salesforce_update_contact
        - salesforce_create_case
        - salesforce_update_case
        - salesforce_add_comment_to_case
        - shopify_get_products
        - shopify_get_order
        - shopify_cancel_order
        - shopify_update_order
        - google_sheets_create_spreadsheet
        - google_sheets_update_spreadsheet
        - google_sheets_read_spreadsheet
        - google_sheets_append_spreadsheet
        - google_sheets_read_row
        - google_gmail_send_email
        - airtable_create_records
        - airtable_delete_records
        - airtable_get_record
        - airtable_list_records
        - airtable_update_records
        - make_run_scenario
        - twilio_send_sms
        - hubspot_create_contact
        - hubspot_create_lead
        - hubspot_create_ticket
      x-enumNames:
        - EXAMPLE_DYNAMIC_SCHEMA
        - ZENDESK_FIND_USER
        - ZENDESK_FIND_GROUP
        - ZENDESK_FIND_TICKET
        - ZENDESK_CREATE_TICKET
        - ZENDESK_UPDATE_TICKET
        - ZENDESK_ADD_TICKET_COMMENT
        - ZENDESK_UPDATE_ORGANIZATION
        - ZENDESK_FIND_LATEST_TICKET_COMMENT
        - SALESFORCE_CREATE_LEAD
        - SALESFORCE_UPDATE_LEAD
        - SALESFORCE_CREATE_CONTACT
        - SALESFORCE_UPDATE_CONTACT
        - SALESFORCE_CREATE_CASE
        - SALESFORCE_UPDATE_CASE
        - SALESFORCE_ADD_COMMENT_TO_CASE
        - SHOPIFY_GET_PRODUCTS
        - SHOPIFY_GET_ORDER
        - SHOPIFY_CANCEL_ORDER
        - SHOPIFY_UPDATE_ORDER
        - GOOGLE_SHEETS_CREATE_SPREADSHEET
        - GOOGLE_SHEETS_UPDATE_SPREADSHEET
        - GOOGLE_SHEETS_READ_SPREADSHEET
        - GOOGLE_SHEETS_APPEND_SPREADSHEET
        - GOOGLE_SHEETS_READ_ROW
        - GOOGLE_GMAIL_SEND_EMAIL
        - AIRTABLE_CREATE_RECORDS
        - AIRTABLE_DELETE_RECORDS
        - AIRTABLE_GET_RECORD
        - AIRTABLE_LIST_RECORDS
        - AIRTABLE_UPDATE_RECORDS
        - MAKE_RUN_SCENARIO
        - TWILIO_SEND_SMS
        - HUBSPOT_CREATE_CONTACT
        - HUBSPOT_CREATE_LEAD
        - HUBSPOT_CREATE_TICKET
    StableIntegrationAddToolResponse:
      type: object
      properties:
        message:
          type: string
          description: A human-readable message confirming the update.
        integrationToolID:
          type: string
          description: The ID to attach the tool with, through the tool create operation.
        created:
          type: boolean
          description: False when the tool was already added to this environment; nothing
            changed then.
      required:
        - message
        - integrationToolID
        - created
  securitySchemes:
    token:
      scheme: bearer
      bearerFormat: JWT
      type: http
      description: Voiceflow bearer token
````
